Index: uk/me/parabola/mkgmap/build/MapArea.java
===================================================================
--- uk/me/parabola/mkgmap/build/MapArea.java	(revision 3346)
+++ uk/me/parabola/mkgmap/build/MapArea.java	(working copy)
@@ -98,7 +98,6 @@
 	public MapArea(MapDataSource src, int resolution) {
 		this.areaResolution = 0;
 		this.bounds = src.getBounds();
-		addToBounds(bounds);
 
 		for (MapPoint p : src.getPoints()) {
 			if(bounds.contains(p.getLocation()))
@@ -119,9 +118,7 @@
 		MapFilterChain chain = new MapFilterChain() {
 			public void doFilter(MapElement element) {
 				MapShape shape = (MapShape) element;
-				shapes.add(shape);
-				addToBounds(shape.getBounds());
-				addSize(element, shape.hasExtendedType()? XT_SHAPE_KIND : SHAPE_KIND);
+				addShape(shape);
 			}
 		};
 
@@ -148,9 +145,7 @@
 		MapFilterChain chain = new MapFilterChain() {
 			public void doFilter(MapElement element) {
 				MapLine line = (MapLine) element;
-				lines.add(line);
-				addToBounds(line.getBounds());
-				addSize(element, line.hasExtendedType()? XT_LINE_KIND : LINE_KIND);
+				addLine(line);
 			}
 		};
 
@@ -173,7 +168,6 @@
 	private MapArea(Area area, int res) {
 		bounds = area;
 		areaResolution = res;
-		addToBounds(area);
 	}
 
 	/**
Index: uk/me/parabola/mkgmap/build/MapSplitter.java
===================================================================
--- uk/me/parabola/mkgmap/build/MapSplitter.java	(revision 3346)
+++ uk/me/parabola/mkgmap/build/MapSplitter.java	(working copy)
@@ -17,6 +17,7 @@
 package uk.me.parabola.mkgmap.build;
 
 import java.util.ArrayList;
+import java.util.Arrays;
 import java.util.List;
 
 import uk.me.parabola.imgfmt.app.Area;
@@ -117,9 +118,12 @@
 	 */
 	private void addAreasToList(MapArea[] areas, List<MapArea> alist, int depth) {
 		int res = zoom.getResolution();
+		int[] ALL_ZERO = new int[6];
 		for (MapArea area : areas) {
 			Area bounds = area.getBounds();
 			int[] sizes = area.getEstimatedSizes();
+			if (depth > 0 && Arrays.equals(sizes, ALL_ZERO))
+				continue;
 			if(log.isInfoEnabled()) {
 				String padding = depth + "                                                                      ";
 				log.info(padding.substring(0, (depth + 1) * 2) + 
